diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
index 73b7bca1d..b33218d76 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -6,6 +6,7 @@ import net.minecraft.core.data.gamerule.GameRuleCollection;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -15,362 +16,279 @@ import java.io.IOException;
 import java.nio.file.Files;
 import java.util.UUID;
 
-public class LevelData
-{
-    private static final Logger LOGGER = LogUtils.getLogger();
-    private long randomSeed;
-    private int spawnX;
-    private int spawnY;
-    private int spawnZ;
-    private long worldTime;
-    private long lastTimePlayed;
-    private long sizeOnDisk;
-    @Deprecated
-    private CompoundTag playerTag;
-    @Deprecated
-    private int dimension;
-    @Deprecated
-    private int gamemode;
-    private @Nullable UUID lastPlayerUUID;
-    private @NotNull String levelName = "DEFAULT NAME";
-    private int saveVersion;
-    private boolean cheatsEnabled;
-    private @NotNull Difficulty difficulty = Difficulty.NORMAL;
-    private boolean difficultyLocked;
-    private GameRuleCollection gameRules;
-    private SpawnerConfig spawnerConfig;
-
+public class LevelData {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
 
-    public LevelData(CompoundTag tag)
-    {
-        readFromCompoundTag(tag);
-    }
+    public static @NotNull LevelData fromCompoundTag(final @NotNull CompoundTag tag) {
+        final long randomSeed = tag.getLong("RandomSeed");
+        final @NotNull String levelName = tag.getString("LevelName");
 
-    //do *not* add @NotNull to name here, breaks modding for some abstract reason
-    public LevelData(long seed, @NotNull String name)
-    {
-        randomSeed = seed;
-        levelName = name;
-        spawnerConfig = new SpawnerConfig();
-        gameRules = new GameRuleCollection();
-    }
-
-    public LevelData(long seed, @NotNull String name, GameRuleCollection gameRules)
-    {
-        randomSeed = seed;
-        levelName = name;
-        spawnerConfig = new SpawnerConfig();
-        this.gameRules = gameRules;
-    }
-
-    public LevelData(LevelData levelData)
-    {
-        randomSeed = levelData.randomSeed;
-        spawnX = levelData.spawnX;
-        spawnY = levelData.spawnY;
-        spawnZ = levelData.spawnZ;
-        worldTime = levelData.worldTime;
-        lastTimePlayed = levelData.lastTimePlayed;
-        sizeOnDisk = levelData.sizeOnDisk;
-        playerTag = levelData.playerTag;
-        dimension = levelData.dimension;
-        levelName = levelData.levelName;
-        saveVersion = levelData.saveVersion;
-        cheatsEnabled = levelData.cheatsEnabled;
-        gamemode = levelData.gamemode;
-        gameRules = levelData.gameRules;
-        spawnerConfig = levelData.getSpawnerConfig();
-        difficulty = levelData.difficulty;
-        difficultyLocked = levelData.difficultyLocked;
-        lastPlayerUUID = levelData.lastPlayerUUID;
-    }
-
-    public LevelData(File worldDir)
-            throws IOException
-    {
-        CompoundTag nbtRootData = null;
-
-        if(!worldDir.exists())
-        {
-            throw new IOException();
-        }
-        File worldLevelDat = new File(worldDir, "level.dat");
-        if(worldLevelDat.exists())
-        {
-            CompoundTag nbtRoot = NbtIo.readCompressed(Files.newInputStream(worldLevelDat.toPath()));
-            nbtRootData = nbtRoot.getCompound("Data");
-        }
-        else
-        {
-            worldLevelDat = new File(worldDir, "level.dat_old");
-            if(worldLevelDat.exists())
-            {
-                CompoundTag oldNbtRoot = NbtIo.readCompressed(Files.newInputStream(worldLevelDat.toPath()));
-                nbtRootData = oldNbtRoot.getCompound("Data");
-            }
-        }
-
-        if (nbtRootData != null)
-        {
-            readFromCompoundTag(nbtRootData);
-        }
-        else
-        {
-            throw new IOException();
-        }
-
-        if (gameRules == null)
-        {
+        final @NotNull GameRuleCollection gameRules;
+        if (tag.containsKey("GameRules")) {
+            final CompoundTag gameRulesTag = tag.getCompound("GameRules");
+            gameRules = GameRuleCollection.readFromNBT(gameRulesTag);
+        } else {
             gameRules = new GameRuleCollection();
         }
 
-        if (spawnerConfig == null) {
+        final @NotNull SpawnerConfig spawnerConfig;
+        if (tag.containsKey("SpawnConfig")) {
+            final CompoundTag spawnConfigTag = tag.getCompound("SpawnConfig");
+            spawnerConfig = SpawnerConfig.createFromTag(spawnConfigTag);
+        } else {
             spawnerConfig = new SpawnerConfig();
         }
-    }
-
-    public CompoundTag getNBTTagCompound()
-    {
-        CompoundTag tag = new CompoundTag();
-        updateTagCompound(tag);
-        return tag;
-    }
-
-    private void updateTagCompound(CompoundTag levelTag)
-    {
-        levelTag.putLong("RandomSeed", randomSeed);
-        levelTag.putInt("SpawnX", spawnX);
-        levelTag.putInt("SpawnY", spawnY);
-        levelTag.putInt("SpawnZ", spawnZ);
-        levelTag.putLong("Time", worldTime);
-        levelTag.putLong("SizeOnDisk", sizeOnDisk);
-        levelTag.putLong("LastPlayed", System.currentTimeMillis());
-        levelTag.putString("LevelName", levelName);
-        levelTag.putInt("version", saveVersion);
-        levelTag.putBoolean("CheatsEnabled", cheatsEnabled);
-        levelTag.putInt("Difficulty", difficulty.id());
-        levelTag.putBoolean("DifficultyLock", difficultyLocked);
-
-        CompoundTag gameRulesTag = new CompoundTag();
-        GameRuleCollection.writeToNBT(gameRulesTag, gameRules);
-        levelTag.put("GameRules", gameRulesTag);
-
-        if (lastPlayerUUID != null) {
-            levelTag.putString("LastPlayerUUID", lastPlayerUUID.toString());
-        }
 
-        if (spawnerConfig != null) {
-            CompoundTag spawnerConfigTag = new CompoundTag();
-            spawnerConfig.writeToTag(spawnerConfigTag);
-            levelTag.put("SpawnConfig", spawnerConfigTag);
+        final @NotNull LevelData data = new LevelData(
+            randomSeed,
+            levelName,
+            gameRules,
+            spawnerConfig
+        );
+
+        data.spawnPos.set(
+            tag.getInteger("SpawnX"),
+            tag.getInteger("SpawnY"),
+            tag.getInteger("SpawnZ")
+        );
+        data.worldTime = tag.getLong("Time");
+        data.lastTimePlayed = tag.getLong("LastPlayed");
+        data.sizeOnDisk = tag.getLong("SizeOnDisk");
+        data.saveVersion = tag.getInteger("version");
+        data.cheatsEnabled = tag.getBoolean("CheatsEnabled");
+        data.setDifficulty(tag.getIntegerOrDefault("Difficulty", Difficulty.NORMAL.id()), true);
+        data.difficultyLocked = tag.getBooleanOrDefault("DifficultyLock", false);
+
+        if (tag.containsKey("Player")) {
+            data.playerTag = tag.getCompound("Player");
         }
-    }
 
-    private void readFromCompoundTag(CompoundTag tag)
-    {
-        randomSeed = tag.getLong("RandomSeed");
-        spawnX = tag.getInteger("SpawnX");
-        spawnY = tag.getInteger("SpawnY");
-        spawnZ = tag.getInteger("SpawnZ");
-        worldTime = tag.getLong("Time");
-        lastTimePlayed = tag.getLong("LastPlayed");
-        sizeOnDisk = tag.getLong("SizeOnDisk");
-        levelName = tag.getString("LevelName");
-        saveVersion = tag.getInteger("version");
-        cheatsEnabled = tag.getBoolean("CheatsEnabled");
-        setDifficulty(tag.getIntegerOrDefault("Difficulty", Difficulty.NORMAL.id()), true);
-        difficultyLocked = tag.getBooleanOrDefault("DifficultyLock", false);
-        if (tag.containsKey("Player"))
-        {
-            playerTag = tag.getCompound("Player");
-            dimension = playerTag.getInteger("Dimension");
-            gamemode = playerTag.getInteger("Gamemode");
-        }
-        if (tag.containsKey("GameRules"))
-        {
-            CompoundTag gameRulesTag = tag.getCompound("GameRules");
-            gameRules = GameRuleCollection.readFromNBT(gameRulesTag);
-        }
-        else
-        {
-            gameRules = new GameRuleCollection();
-        }
         if (tag.containsKey("LastPlayerUUID")) {
-            lastPlayerUUID = UUID.fromString(tag.getString("LastPlayerUUID"));
+            data.lastPlayerUUID = UUID.fromString(tag.getString("LastPlayerUUID"));
         }
 
-        if (tag.containsKey("SpawnConfig")) {
-            CompoundTag spawnConfigTag = tag.getCompound("SpawnConfig");
-            spawnerConfig = SpawnerConfig.createFromTag(spawnConfigTag);
-        } else {
-            spawnerConfig = new SpawnerConfig();
+        return data;
+    }
+
+    public static @NotNull CompoundTag toCompoundTag(final @NotNull LevelData levelData, final @NotNull CompoundTag out) {
+        out.putLong("RandomSeed", levelData.randomSeed);
+        out.putInt("SpawnX", levelData.spawnPos.x);
+        out.putInt("SpawnY", levelData.spawnPos.y);
+        out.putInt("SpawnZ", levelData.spawnPos.z);
+        out.putLong("Time", levelData.worldTime);
+        out.putLong("SizeOnDisk", levelData.sizeOnDisk);
+        out.putLong("LastPlayed", System.currentTimeMillis());
+        out.putString("LevelName", levelData.levelName);
+        out.putInt("version", levelData.saveVersion);
+        out.putBoolean("CheatsEnabled", levelData.cheatsEnabled);
+        out.putInt("Difficulty", levelData.difficulty.id());
+        out.putBoolean("DifficultyLock", levelData.difficultyLocked);
+
+        final CompoundTag gameRulesTag = new CompoundTag();
+        GameRuleCollection.writeToNBT(gameRulesTag, levelData.gameRules);
+        out.put("GameRules", gameRulesTag);
+
+        if (levelData.lastPlayerUUID != null) {
+            out.putString("LastPlayerUUID", levelData.lastPlayerUUID.toString());
         }
-    }
 
-    public long getRandomSeed()
-    {
-        return randomSeed;
-    }
+        final CompoundTag spawnerConfigTag = new CompoundTag();
+        levelData.spawnerConfig.writeToTag(spawnerConfigTag);
+        out.put("SpawnConfig", spawnerConfigTag);
 
-    public int getSpawnX()
-    {
-        return spawnX;
+        return out;
     }
 
-    public int getSpawnY()
-    {
-        return spawnY;
-    }
+    public static @NotNull LevelData fromWorldDir(final @NotNull File worldDir) throws IOException {
+        @Nullable CompoundTag nbtRootData = null;
 
-    public int getSpawnZ()
-    {
-        return spawnZ;
-    }
+        if (!worldDir.exists()) {
+            throw new IOException();
+        }
+        @NotNull File worldLevelDat = new File(worldDir, "level.dat");
+        if (worldLevelDat.exists()) {
+            final @NotNull CompoundTag nbtRoot = NbtIo.readCompressed(Files.newInputStream(worldLevelDat.toPath()));
+            nbtRootData = nbtRoot.getCompound("Data");
+        } else {
+            worldLevelDat = new File(worldDir, "level.dat_old");
+            if (worldLevelDat.exists()) {
+                final @NotNull CompoundTag oldNbtRoot = NbtIo.readCompressed(Files.newInputStream(worldLevelDat.toPath()));
+                nbtRootData = oldNbtRoot.getCompound("Data");
+            }
+        }
 
-    public long getWorldTime()
-    {
-        return worldTime;
+        if (nbtRootData != null) {
+            return LevelData.fromCompoundTag(nbtRootData);
+        } else {
+            throw new IOException();
+        }
     }
 
-    public long getSizeOnDisk()
-    {
-        return sizeOnDisk;
-    }
+    private final long randomSeed;
+    private final @NotNull String levelName;
+    private final @NotNull TilePos spawnPos = new TilePos();
+    private final @NotNull GameRuleCollection gameRules;
+    private final @NotNull SpawnerConfig spawnerConfig;
 
-    @Deprecated
-    public CompoundTag getPlayerNBTTagCompound()
-    {
-        return playerTag;
-    }
+    private long worldTime;
+    private long lastTimePlayed;
+    private long sizeOnDisk;
+    private @Nullable UUID lastPlayerUUID;
+    private int saveVersion;
+    private boolean cheatsEnabled;
+    private @NotNull Difficulty difficulty = Difficulty.NORMAL;
+    private boolean difficultyLocked;
 
     @Deprecated
-    public int getDimension()
-    {
-        return dimension;
-    }
-
-    public @Nullable UUID getLastPlayerUUID() {
-        return lastPlayerUUID;
-    }
-
-    public void setSpawnX(int x)
-    {
-        spawnX = x;
+    private @Nullable CompoundTag playerTag;
+
+    private LevelData(
+        final long randomSeed,
+        final @NotNull String levelName,
+        final @NotNull GameRuleCollection gameRules,
+        final @NotNull SpawnerConfig spawnerConfig
+    ) {
+        this.randomSeed = randomSeed;
+        this.levelName = levelName;
+        this.gameRules = gameRules;
+        this.spawnerConfig = spawnerConfig;
+    }
+
+    public LevelData(
+        final long randomSeed,
+        final @NotNull String name
+    ) {
+        this(
+            randomSeed,
+            name,
+            new GameRuleCollection(),
+            new SpawnerConfig()
+        );
+    }
+
+    public LevelData(
+        final long randomSeed,
+        final @NotNull String name,
+        final @NotNull GameRuleCollection gameRules
+    ) {
+        this(
+            randomSeed,
+            name,
+            gameRules,
+            new SpawnerConfig()
+        );
+    }
+
+    public LevelData(final @NotNull LevelData levelData) {
+        this(levelData.randomSeed, levelData.levelName, levelData.gameRules, levelData.spawnerConfig);
+
+        this.spawnPos.set(levelData.spawnPos);
+        this.worldTime = levelData.worldTime;
+        this.lastTimePlayed = levelData.lastTimePlayed;
+        this.sizeOnDisk = levelData.sizeOnDisk;
+        this.playerTag = levelData.playerTag;
+        this.saveVersion = levelData.saveVersion;
+        this.cheatsEnabled = levelData.cheatsEnabled;
+        this.difficulty = levelData.difficulty;
+        this.difficultyLocked = levelData.difficultyLocked;
+        this.lastPlayerUUID = levelData.lastPlayerUUID;
     }
 
-    public void setSpawnY(int y)
-    {
-        spawnY = y;
+    @Deprecated
+    public @Nullable CompoundTag getPlayerTag() {
+        return this.playerTag;
     }
 
-    public void setSpawnZ(int z)
-    {
-        spawnZ = z;
+    public long getRandomSeed() {
+        return this.randomSeed;
     }
 
-    public void setWorldTime(long time)
-    {
-        worldTime = time;
+    public @NotNull TilePos getSpawnPos() {
+        return this.spawnPos;
     }
 
-    public void setSizeOnDisk(long size)
-    {
-        sizeOnDisk = size;
+    public long getWorldTime() {
+        return this.worldTime;
     }
 
-    @Deprecated
-    public void setPlayerNBTTagCompound(CompoundTag tag)
-    {
-        playerTag = tag;
+    public void setWorldTime(final long time) {
+        this.worldTime = time;
     }
 
-    public void setLastPlayerUUID(@Nullable UUID lastPlayerUUID) {
-        this.lastPlayerUUID = lastPlayerUUID;
+    public long getSizeOnDisk() {
+        return this.sizeOnDisk;
     }
 
-    public void setSpawn(int x, int y, int z)
-    {
-        spawnX = x;
-        spawnY = y;
-        spawnZ = z;
+    public void setSizeOnDisk(final long size) {
+        this.sizeOnDisk = size;
     }
 
-    public String getWorldName()
-    {
-        return levelName;
+    public @NotNull GameRuleCollection getGameRules() {
+        return this.gameRules;
     }
 
-    public void setWorldName(String s)
-    {
-        levelName = s;
+    public @NotNull SpawnerConfig getSpawnerConfig() {
+        return this.spawnerConfig;
     }
 
-    public int getSaveVersion()
-    {
-        return saveVersion;
+    public @Nullable UUID getLastPlayerUUID() {
+        return this.lastPlayerUUID;
     }
 
-    public void setSaveVersion(int i)
-    {
-        saveVersion = i;
+    public void setLastPlayerUUID(final @Nullable UUID lastPlayerUUID) {
+        this.lastPlayerUUID = lastPlayerUUID;
     }
 
-    public long getLastTimePlayed()
-    {
-        return lastTimePlayed;
+    public @NotNull String getWorldName() {
+        return this.levelName;
     }
 
-    @Deprecated
-    public int getGamemode()
-    {
-    	return gamemode;
+    public int getSaveVersion() {
+        return this.saveVersion;
     }
 
-    @Deprecated
-    public void setGamemode(int gamemode)
-    {
-    	this.gamemode = gamemode;
+    public void setSaveVersion(final int i) {
+        this.saveVersion = i;
     }
 
-    public GameRuleCollection getGameRules()
-    {
-        return gameRules;
+    public long getLastTimePlayed() {
+        return this.lastTimePlayed;
     }
 
-    public SpawnerConfig getSpawnerConfig() {
-        return spawnerConfig;
+    public boolean getCheatsEnabled() {
+        return this.cheatsEnabled;
     }
 
-    public boolean getCheatsEnabled()
-    {
-    	return cheatsEnabled;
+    public void setCheatsEnabled(final boolean enabled) {
+        this.cheatsEnabled = enabled;
     }
 
-    public void setCheatsEnabled(boolean enabled)
-    {
-    	this.cheatsEnabled = enabled;
-    }
+    public void setDifficulty(final @NotNull Difficulty difficulty, final boolean overrideLock) {
+        if (!overrideLock && this.difficultyLocked) {
+            return;
+        }
 
-    public void setDifficulty(Difficulty difficulty, boolean overrideLock) {
-        if (!overrideLock && difficultyLocked) return;
         this.difficulty = difficulty;
     }
 
-    public void setDifficulty(int difficulty, boolean overrideLock) {
-        if (!overrideLock && difficultyLocked) return;
+    public void setDifficulty(int difficulty, final boolean overrideLock) {
+        if (!overrideLock && this.difficultyLocked) {
+            return;
+        }
+
         if (difficulty < 0) {
-            LOGGER.warn("Attempted to set difficulty to '{}' which is less then 0!", difficulty);
+            LOGGER.warn("Attempted to set difficulty to '{}' which is less than 0!", difficulty);
             difficulty = 0;
         }
         if (difficulty >= Difficulty.values().length) {
-            LOGGER.error("Attempted to set difficulty to '{}' which is more then the '{}' difficulties!", difficulty, Difficulty.values().length);
+            LOGGER.error("Attempted to set difficulty to '{}' which is more than the '{}' difficulties!", difficulty, Difficulty.values().length);
             difficulty = Difficulty.values().length - 1;
         }
-        setDifficulty(Difficulty.values()[difficulty], overrideLock);
+        this.setDifficulty(Difficulty.values()[difficulty], overrideLock);
     }
 
-    public Difficulty getDifficulty() {
-        return difficulty;
+    public @NotNull Difficulty getDifficulty() {
+        return this.difficulty;
     }
 
     public void setDifficultyLocked() {
@@ -378,6 +296,6 @@ public class LevelData
     }
 
     public boolean getDifficultyLocked() {
-        return difficultyLocked;
+        return this.difficultyLocked;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java
index a74037d40..3b03fcd78 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorage.java
@@ -2,8 +2,10 @@ package net.minecraft.core.world.save;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.saveddata.SavedData;
+import net.minecraft.core.world.saveddata.SavedDataStorage;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -11,19 +13,18 @@ import java.io.File;
 import java.util.List;
 import java.util.UUID;
 
-public interface LevelStorage extends PlayerIO
-{
+public interface LevelStorage extends PlayerIO {
 	/**
 	 * Loads the level data for this save.
 	 * @return The loaded level data for this save.
 	 */
-	LevelData getLevelData();
+	@Nullable LevelData getLevelData();
 
 	/**
 	 * Loads the level data for this save in raw NBT format.
 	 * @return The loaded level data for this save.
 	 */
-	CompoundTag getLevelDataRaw();
+	@Nullable CompoundTag getLevelDataRaw();
 
 	/**
 	 * Ensures the save file lock from this session is still valid.
@@ -35,7 +36,7 @@ public interface LevelStorage extends PlayerIO
 	 * @param dimension The dimension to obtain the chunk loader for.
 	 * @return The instantiated chunk loader for the given dimension.
 	 */
-	IChunkLoader getChunkLoader(Dimension dimension);
+	@Nullable ChunkLoader getChunkLoader(@NotNull Dimension dimension);
 
 	/**
 	 * Saves the level data and data for any players.
@@ -43,53 +44,53 @@ public interface LevelStorage extends PlayerIO
 	 * @param levelData The level data to save.
 	 * @param playerList A list of players whose data should be saved.
 	 */
-	void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList);
+	void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<@NotNull Player> playerList);
 
 	/**
 	 * Saves the level data.
 	 * @param levelData The level data to save.
 	 */
-	void saveLevelData(LevelData levelData);
+	void saveLevelData(@NotNull LevelData levelData);
 
 	/**
 	 * Saves the level data using raw NBT.
 	 * @param levelDataTag The level data to save.
 	 */
-	void saveLevelDataRaw(CompoundTag levelDataTag);
+	void saveLevelDataRaw(@NotNull CompoundTag levelDataTag);
 
 	/**
 	 * Loads the dimension data for a given dimension.
-	 * @param dimensionId The ID of the dimension to read the data of.
+	 * @param dimension The dimension whose data should be read.
 	 * @return The dimension data.
 	 */
-	DimensionData getDimensionData(int dimensionId);
+	@Nullable DimensionData getDimensionData(@NotNull Dimension dimension);
 
 	/**
 	 * Loads the dimension data for a given dimension as raw NBT.
-	 * @param dimensionId The ID of the dimension to read the data of.
+	 * @param dimension The dimension whose data should be read.
 	 * @return The raw dimension data.
 	 */
-	CompoundTag getDimensionDataRaw(int dimensionId);
+	@Nullable CompoundTag getDimensionDataRaw(@NotNull Dimension dimension);
 
 	/**
 	 * Saves the dimension data for a given dimension.
 	 * @param dimensionId The ID of the dimension to save.
 	 * @param dimensionData The dimension data to save.
 	 */
-	void saveDimensionData(int dimensionId, DimensionData dimensionData);
+	void saveDimensionData(int dimensionId, @NotNull DimensionData dimensionData);
 
 	/**
 	 * Saves the dimension data for a given dimension as raw NBT.
 	 * @param dimensionId The ID of the dimension to save.
 	 * @param dimensionDataTag The dimension data to save.
 	 */
-	void saveDimensionDataRaw(int dimensionId, CompoundTag dimensionDataTag);
+	void saveDimensionDataRaw(int dimensionId, @NotNull CompoundTag dimensionDataTag);
 
 	@Nullable PlayerIO getPlayerFileData();
 
 	@Nullable CompoundTag getPlayerData(@Nullable String username, @NotNull UUID uuid);
 
-	File getDataFile(String fileName);
-
+	@Nullable File getDataFile(@NotNull String fileName);
 
+	@NotNull SavedDataStorage getSavedDataStorage();
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
index c0153e7ce..672b374c2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
@@ -7,7 +7,8 @@ import com.mojang.nbt.NbtIo;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderLegacy;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.saveddata.SavedDataStorage;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -30,6 +31,7 @@ public abstract class LevelStorageBase implements LevelStorage
 	protected final File dataDirectory;
 	protected final long now = System.currentTimeMillis();
 	protected final ISaveFormat saveFormat;
+	private final @NotNull SavedDataStorage savedDataStorage;
 
 	public LevelStorageBase(ISaveFormat saveFormat, File savesDir, String worldDirName)
 	{
@@ -42,6 +44,8 @@ public abstract class LevelStorageBase implements LevelStorage
 		dataDirectory.mkdirs();
 		playersDirectory.mkdirs();
 		lockSession();
+
+		this.savedDataStorage = new SavedDataStorage(this);
 	}
 
 	private void lockSession()
@@ -84,7 +88,7 @@ public abstract class LevelStorageBase implements LevelStorage
 	}
 
 	@Override
-	public IChunkLoader getChunkLoader(Dimension dimension)
+	public @Nullable ChunkLoader getChunkLoader(@NotNull Dimension dimension)
 	{
 		File dimDir = saveFormat.getDimensionRootDir(worldDirName, dimension);
 		dimDir.mkdirs();
@@ -93,33 +97,33 @@ public abstract class LevelStorageBase implements LevelStorage
 	}
 
 	@Override
-	public LevelData getLevelData()
+	public @Nullable LevelData getLevelData()
 	{
 		return saveFormat.getLevelData(worldDirName);
 	}
 
 	@Override
-	public CompoundTag getLevelDataRaw()
+	public @Nullable CompoundTag getLevelDataRaw()
 	{
 		return saveFormat.getLevelDataRaw(worldDirName);
 	}
 
 	@Override
-	public DimensionData getDimensionData(int dimensionId)
+	public @Nullable DimensionData getDimensionData(@NotNull Dimension dimension)
 	{
-		return saveFormat.getDimensionData(worldDirName, dimensionId);
+		return saveFormat.getDimensionData(worldDirName, dimension);
 	}
 
 	@Override
-	public CompoundTag getDimensionDataRaw(int dimensionId)
+	public @Nullable CompoundTag getDimensionDataRaw(@NotNull Dimension dimension)
 	{
-		return saveFormat.getDimensionDataRaw(worldDirName, dimensionId);
+		return saveFormat.getDimensionDataRaw(worldDirName, dimension);
 	}
 
 	@Override
 	public void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList)
 	{
-		CompoundTag dataTag = levelData.getNBTTagCompound();
+		CompoundTag dataTag = LevelData.toCompoundTag(levelData, new CompoundTag());
 		CompoundTag savedTag = new CompoundTag();
 		savedTag.put("Data", dataTag);
 		try
@@ -155,16 +159,18 @@ public abstract class LevelStorageBase implements LevelStorage
 				LOGGER.error("Failed to save player data for player '{}'!", player.username, e);
 			}
 		}
+
+		this.savedDataStorage.save();
 	}
 
 	@Override
-	public void saveLevelData(LevelData levelData)
+	public void saveLevelData(@NotNull LevelData levelData)
 	{
-		saveLevelDataRaw(levelData.getNBTTagCompound());
+		saveLevelDataRaw(LevelData.toCompoundTag(levelData, new CompoundTag()));
 	}
 
 	@Override
-	public void saveLevelDataRaw(CompoundTag levelDataTag)
+	public void saveLevelDataRaw(@NotNull CompoundTag levelDataTag)
 	{
 		CompoundTag rootTag = new CompoundTag();
 		rootTag.put("Data", levelDataTag);
@@ -198,13 +204,13 @@ public abstract class LevelStorageBase implements LevelStorage
 	}
 
 	@Override
-	public void saveDimensionData(int dimensionId, DimensionData dimensionData)
+	public void saveDimensionData(int dimensionId, @NotNull DimensionData dimensionData)
 	{
-		saveDimensionDataRaw(dimensionId, dimensionData.toNBTTag());
+		saveDimensionDataRaw(dimensionId, DimensionData.toCompoundTag(dimensionData, new CompoundTag()));
 	}
 
 	@Override
-	public void saveDimensionDataRaw(int dimensionId, CompoundTag dimensionDataTag)
+	public void saveDimensionDataRaw(int dimensionId, @NotNull CompoundTag dimensionDataTag)
 	{
 		CompoundTag rootTag = new CompoundTag();
 		rootTag.put("Data", dimensionDataTag);
@@ -241,7 +247,7 @@ public abstract class LevelStorageBase implements LevelStorage
 	}
 
 	@Override
-	public File getDataFile(String fileName)
+	public File getDataFile(@NotNull String fileName)
 	{
 		return new File(dataDirectory, fileName + ".dat");
 	}
@@ -278,9 +284,9 @@ public abstract class LevelStorageBase implements LevelStorage
 			player.load(tag);
 			return;
 		}
-		LevelData data;
-		if ((data = getLevelData()) != null){
-			tag = data.getPlayerNBTTagCompound();
+		LevelData data = getLevelData();
+		if (data != null){
+			tag = data.getPlayerTag();
 			if (tag != null) {
 				player.load(tag);
 			}
@@ -293,6 +299,11 @@ public abstract class LevelStorageBase implements LevelStorage
 		return this;
 	}
 
+	@Override
+	public @NotNull SavedDataStorage getSavedDataStorage() {
+		return this.savedDataStorage;
+	}
+
 	public @Nullable CompoundTag getPlayerData(@Nullable String username, @NotNull UUID uuid)
 	{
 		try
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageCore.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageCore.java
index ea71bcfee..9380aa7ff 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageCore.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageCore.java
@@ -3,8 +3,9 @@ package net.minecraft.core.world.save;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderRegionAsync;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.File;
 import java.util.List;
@@ -19,7 +20,7 @@ public class LevelStorageCore
     }
     
     @Override
-    public IChunkLoader getChunkLoader(Dimension dimension)
+    public @Nullable ChunkLoader getChunkLoader(@NotNull Dimension dimension)
     {
         File dimDir = saveFormat.getDimensionRootDir(worldDirName, dimension);
         dimDir.mkdirs();
